package com.jjoe64.graphviewdemos;
import java.util.ArrayList;
import com.jjoe64.graphview.ValueDependentColor;
import com.jjoe64.graphview.GraphViewSeries.GraphViewSeriesStyle;
import com.jjoe64.graphview.BarGraphView;
import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.GraphViewSeries;
import com.jjoe64.graphview.GraphView.GraphViewData;
import android.graphics.Color;
import com.jjoe64.graphview.GraphViewDataInterface;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.PowerManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;

public class MainActivity extends Activity {
	GraphViewSeries exampleSeries;
	GraphView graphView;
	
	private SensorManager myManager = null;
	float[] gyrs = new float[3];
	float[] accels = new float[3];
	float[] RotationMat = new float[9];
	float[] InclinationMat = new float[9];
	float[] attitude = new float[3];
	
	TextView tv, tv2, tv3, tv4;
	final static double RAD2DEG = 180/Math.PI;
	PowerManager pm;
	PowerManager.WakeLock wakeLock;

	private ArrayList<String> arrayList;
    private MyCustomAdapter mAdapter;
    private TCPClient mTcpClient;
    AlertDialog alertDialogStores;
    int pitchMin;
    int pitchMax;
    int rowMin;
    int rowMax;
    int azimuthMin;
    int azimuthMax;
    boolean wakeLockOn;
    GraphViewSeriesStyle seriesStyle;
    AlertDialog.Builder alert;
    connectTask connection;
    
    @SuppressWarnings("deprecation")
	@Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        wakeLockOn = false;
        
        pitchMin = -5;
        pitchMax = 5;
        rowMin = -5;
	    rowMax =  5;
	    azimuthMin = -5;
	    azimuthMax = 5;
        
        seriesStyle = new GraphViewSeriesStyle();
        seriesStyle.setValueDependentColor(new ValueDependentColor() {
            @Override
            public int get(GraphViewDataInterface data) {
                    //set the color of each bar
            		if(data.getX() == 1){
            			return Color.rgb(40,212,66);
            		}
            		else if(data.getX() == 2){
            			return Color.rgb(40,60,212);
            		}
            		else{
            			return Color.rgb(245,72,42);
            		}
            }
    });
        
        tv=(TextView)findViewById(R.id.text_view);
		 tv2=(TextView)findViewById(R.id.text_view2);
		 tv3=(TextView)findViewById(R.id.text_view3);
		 tv4=(TextView)findViewById(R.id.text_view4);
		 
		 PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
		  wakeLock = pm.newWakeLock(
				  PowerManager.FULL_WAKE_LOCK, "My wakelook");
		
		 arrayList = new ArrayList<String>();
		 mAdapter = new MyCustomAdapter(this, arrayList);
		 
		 //Start the TCP Connection
		 connection = new connectTask();
		 connection.execute("");
		
		 
		 // a button to show the pop up with a list view
	        View.OnClickListener handler = new View.OnClickListener(){
	            public void onClick(View v) {
	            	showPopUp();
	            	
	            	
	            }
	        };

	        findViewById(R.id.buttonShowPopUp).setOnClickListener(handler);
		 
        exampleSeries = new GraphViewSeries("aaa", seriesStyle, new GraphViewData[] {
				new GraphViewData(1, -180)
				, new GraphViewData(2, -180)
				, new GraphViewData(3, -180) // another frequency
				
		});
		
		graphView = new BarGraphView(
				this // context
				, "Motion Graph" // heading
		);
		
		graphView.addSeries(exampleSeries);
		graphView.setHorizontalLabels(new String[] {"Azimuth", "Pitch", "Roll", ""});
		graphView.setManualYAxisBounds(180, -180);
		LinearLayout layout = (LinearLayout) findViewById(R.id.graph1);
		layout.addView(graphView);

    }

    //Socket Setting Dialog Box
    public void showPopUp(){
    	LayoutInflater factory = LayoutInflater.from(this);
		 final View textEntryView = factory.inflate(R.layout.text_entry, null);
		 //text_entry is an Layout XML file containing two text field to display in alert dialog
		 final EditText input1 = (EditText) textEntryView.findViewById(R.id.EditText1);
		 final EditText input2 = (EditText) textEntryView.findViewById(R.id.EditText2);             
		 input1.setText(connection.getServerIP(), TextView.BufferType.EDITABLE);
		 input2.setText(connection.getServerPort(), TextView.BufferType.EDITABLE);
		  alert = new AlertDialog.Builder(this);

		 alert.setIcon(R.drawable.icon)
		      .setTitle("Socket Setting")
		      .setView(textEntryView)
		      .setPositiveButton("Save", 
		          new DialogInterface.OnClickListener() {
		              public void onClick(DialogInterface dialog, int whichButton) {
		                     String IP = input1.getText().toString();
		                     String port = input2.getText().toString();
		                     /* User clicked OK so do some stuff */
		                     connection.reconnect(IP, port);
		                     
		              }
		          })
		      .setNegativeButton("Cancel",
		          new DialogInterface.OnClickListener() {
		              public void onClick(DialogInterface dialog,
		                     int whichButton) {
		              }
		          });

		 	alert.show();
    }
    
//Update the Graph and sends Orientation data to the Server
private final SensorEventListener mySensorListener = new SensorEventListener(){
		
		public void onSensorChanged(SensorEvent event) {
			// TODO Auto-generated method stub
			
			 if (event.sensor.getType() == Sensor.TYPE_GYROSCOPE) {	 
				gyrs = event.values;
			 }
			 else if(event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
				 accels = event.values;		 
			 }
			 
			 SensorManager.getRotationMatrix(RotationMat, InclinationMat, accels, gyrs);
			 SensorManager.getOrientation(RotationMat, attitude);
			 exampleSeries = new GraphViewSeries("aaa", seriesStyle, new GraphViewData[] {
						
					 new GraphViewData(1, attitude[0]*RAD2DEG)
					, new GraphViewData(2, attitude[1]*RAD2DEG)
					, new GraphViewData(3, attitude[2]*RAD2DEG)
							});
			 
			 
			 String message =  (attitude[0]*RAD2DEG) + " "  +  (attitude[1]*RAD2DEG) + " " +  (attitude[2]*RAD2DEG) + ";";
			 
             //add the text in the arrayList
             arrayList.add(message);     

             //refresh the list
             mAdapter.notifyDataSetChanged();
             
			
			
			graphView.removeAllSeries();
			graphView.addSeries(exampleSeries);
			
			int pitch = (int) (attitude[1]*RAD2DEG);
			int row = (int) (attitude[2]*RAD2DEG);
			tv.setText("Azimuth: " + (int) (attitude[0]*RAD2DEG) + "");
			tv2.setText("Pitch: "  + (int) (attitude[1]*RAD2DEG) +"");
			tv3.setText("Roll: " + (int) (attitude[2]*RAD2DEG) + "");
			if (pitch < pitchMin) {
				sendData(message);
			} else if (pitch > pitchMax) {
				sendData(message);
			}
			
			if (row < rowMin) {
				sendData(message);
			} else if (row > rowMax) {
				sendData(message);
			}
		}
		
		public void onAccuracyChanged(Sensor event, int accuracy) {}
		
	};
	
	
	
	public void onDestroy() {
		// TODO Auto-generated method stub
		
		super.onDestroy();
		if (wakeLockOn == true){
			myManager.unregisterListener(mySensorListener, myManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER) );
			myManager.unregisterListener(mySensorListener, myManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE) );
		}	
		
	}
	
	//Sending data to the server
	public void sendData(String message){
		if (mTcpClient != null) {
            mTcpClient.sendMessage(message);
        }
	}
	
	//Start Button onClick Event
	public void sendMessage(View view) {	
		myManager =(SensorManager)getSystemService(SENSOR_SERVICE);
		myManager.registerListener(mySensorListener, 
								myManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), 
							SensorManager.SENSOR_DELAY_NORMAL);
		
		myManager.registerListener(mySensorListener, 
				myManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE), 
				SensorManager.SENSOR_DELAY_NORMAL);
		wakeLock.acquire();
		wakeLockOn = true;
		
		
    }
	
	//Stop Button onClick Event
	public void stop(View view){
		onDestroy();
		if (wakeLockOn == true){
			wakeLock.release();
			wakeLockOn = false;
		}
	}	
	
	//Creating the Connection between the device and the server
	public class connectTask extends AsyncTask<String,String,TCPClient> {
		public  String SERVERIP = "172.23.204.9"; //Default computer IP address
	    public  int SERVERPORT = 4444; //Default computer Port number
        @Override
        protected TCPClient doInBackground(String... message) {
 
            //we create a TCPClient object and
            mTcpClient = new TCPClient(new TCPClient.OnMessageReceived() {
                @Override
                //here the messageReceived method is implemented
                public void messageReceived(String message) {
                    //this method calls the onProgressUpdate
                    publishProgress(message);
                    
                }
            }, SERVERIP, SERVERPORT);
            mTcpClient.run();
            
            return null;
        }
        
        public String getServerIP(){
    	    return SERVERIP;
        }
        
        
        public String getServerPort(){
    	    return SERVERPORT + "";
        }
        

        public void reconnect(String IP, String port){
    	    SERVERIP = IP;
    	    SERVERPORT = Integer.parseInt(port);
    	    doInBackground();
    	    new Thread(new Runnable() {
    	        public void run() {
    	        	doInBackground();
    	        }
    	      }).start();
        }
        
        @Override
        protected void onProgressUpdate(String... values) {
            super.onProgressUpdate(values);
 
            //in the arrayList we add the messaged received from server
            arrayList.add(values[0]);
            // notify the adapter that the data set has changed. This means that new message received
            // from server was added to the list
            mAdapter.notifyDataSetChanged();
        }
    }
	
	
}